| Home · All Classes · All Namespaces · Modules · Functions · Files

Public Slots | Signals | Public Member Functions | Static Public Member Functions | Protected Member Functions
Tp::Client::ConnectionInterfaceCapabilitiesInterface Class Reference
Connection proxies

`#include <TelepathyQt/Connection>`

Inherits Tp::AbstractInterface.

List of all members.

## Public Slots

- QDBusPendingReply
  < Tp::CapabilityPairList > AdvertiseCapabilities (const Tp::CapabilityPairList &add, const QStringList &remove, int timeout=-1)
- QDBusPendingReply
  < Tp::ContactCapabilityList > GetCapabilities (const Tp::UIntList &handles, int timeout=-1)

## Signals

- void CapabilitiesChanged (const Tp::CapabilityChangeList &caps)

## Public Member Functions

- ConnectionInterfaceCapabilitiesInterface (const QString &busName, const QString &objectPath, QObject *parent=0)
- ConnectionInterfaceCapabilitiesInterface (const QDBusConnection &connection, const QString &busName, const QString &objectPath, QObject *parent=0)
- ConnectionInterfaceCapabilitiesInterface (Tp::DBusProxy *proxy)
- ConnectionInterfaceCapabilitiesInterface (const Tp::Client::ConnectionInterface &mainInterface)
- ConnectionInterfaceCapabilitiesInterface (const Tp::Client::ConnectionInterface &mainInterface, QObject *parent)
- Tp::PendingVariantMap * requestAllProperties () const

## Static Public Member Functions

- static QLatin1String staticInterfaceName ()

## Protected Member Functions

- virtual void invalidate (Tp::DBusProxy *, const QString &, const QString &)

## Detailed Description

Proxy class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.Connection.Interface.Capabilities".

## Constructor & Destructor Documentation

Tp::Client::ConnectionInterfaceCapabilitiesInterface::ConnectionInterfaceCapabilitiesInterface | ( | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a ConnectionInterfaceCapabilitiesInterface associated with the given object on the session bus.

Parameters:

  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

Tp::Client::ConnectionInterfaceCapabilitiesInterface::ConnectionInterfaceCapabilitiesInterface | ( | const QDBusConnection & | connection,
|  | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a ConnectionInterfaceCapabilitiesInterface associated with the given object on the given bus.

Parameters:

  connection | The bus via which the object can be reached.
  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

Tp::Client::ConnectionInterfaceCapabilitiesInterface::ConnectionInterfaceCapabilitiesInterface | ( | Tp::DBusProxy * | proxy | ) |

Creates a ConnectionInterfaceCapabilitiesInterface associated with the same object as the given proxy.

Parameters:

  proxy | The proxy to use. It will also be the QObject::parent() for this object.

Tp::Client::ConnectionInterfaceCapabilitiesInterface::ConnectionInterfaceCapabilitiesInterface | ( | const Tp::Client::ConnectionInterface & | mainInterface | ) | `[explicit]`

Creates a ConnectionInterfaceCapabilitiesInterface associated with the same object as the given proxy. Additionally, the created proxy will have the same parent as the given proxy.

Parameters:

  mainInterface | The proxy to use.

Tp::Client::ConnectionInterfaceCapabilitiesInterface::ConnectionInterfaceCapabilitiesInterface | ( | const Tp::Client::ConnectionInterface & | mainInterface,
|  | QObject * | parent
| ) |  |

Creates a ConnectionInterfaceCapabilitiesInterface associated with the same object as the given proxy. However, a different parent object can be specified.

Parameters:

  mainInterface | The proxy to use.
  parent | Passed to the parent class constructor.

## Member Function Documentation

static QLatin1String Tp::Client::ConnectionInterfaceCapabilitiesInterface::staticInterfaceName | ( |  | ) | `[inline, static]`

Returns the name of the interface "org.freedesktop.Telepathy.Connection.Interface.Capabilities", which this class represents.

Returns:
  The D-Bus interface name.

Tp::PendingVariantMap* Tp::Client::ConnectionInterfaceCapabilitiesInterface::requestAllProperties | ( |  | ) | const`[inline]`

Request all of the DBus properties on the interface.

Returns:
  A pending variant map which will emit finished when the properties have been retrieved.

QDBusPendingReply<Tp::CapabilityPairList> Tp::Client::ConnectionInterfaceCapabilitiesInterface::AdvertiseCapabilities | ( | const Tp::CapabilityPairList & | add,
|  | const QStringList & | remove,
|  | int | timeout = `-1`
| ) |  | `[inline, slot]`

Begins a call to the D-Bus method `AdvertiseCapabilities` on the remote object.

Used by user interfaces to indicate which channel types they are able to handle on this connection. Because these may be provided by different client processes, this method accepts channel types to add and remove from the set already advertised on this connection. The type of advertised capabilities (create versus invite) is protocol-dependent and hence cannot be set by the this method. In the case of a client adding an already advertised channel type but with new channel type specific flags, the connection manager should simply add the new flags to the set of advertised capabilities.

Upon a successful invocation of this method, the CapabilitiesChanged() signal will be emitted for the user's own handle ( ConnectionInterface::GetSelfHandle() ) by the connection manager to indicate the changes that have been made. This signal should also be monitored to ensure that the set is kept accurate - for example, a client may remove capabilities or type specific capability flags when it exits which are still provided by another client.

On connections managed by the ChannelDispatcherInterface , this method SHOULD NOT be used by clients other than the ChannelDispatcher itself.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  add

  An array of structures containing:
  - a string channel type
  - a bitwise OR of type specific capability flags

  remove | An array of D-Bus interface names of channel types to remove
  timeout | The timeout in milliseconds.

Returns:

An array of structures describing the current capabilities containing: a string channel type a bitwise OR of type specific capability flags

QDBusPendingReply<Tp::ContactCapabilityList> Tp::Client::ConnectionInterfaceCapabilitiesInterface::GetCapabilities | ( | const Tp::UIntList & | handles,
|  | int | timeout = `-1`
| ) |  | `[inline, slot]`

Begins a call to the D-Bus method `GetCapabilities` on the remote object.

Returns an array of capabilities for the given contact handles.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  handles | An array of contact handles for this connection. This may include zero, which originally meant a query for capabilities available on the connection itself. This usage is deprecated; clients SHOULD NOT do this, and connection managers SHOULD proceed as though zero had not been present in this list.
  timeout | The timeout in milliseconds.

Returns:

An array of structures containing:

- an integer handle representing the contact
- a string channel type
- a bitwise OR of generic capability flags for the type
- a bitwise OR of type specific capability flags for the type

void Tp::Client::ConnectionInterfaceCapabilitiesInterface::CapabilitiesChanged | ( | const Tp::CapabilityChangeList & | caps | ) | `[signal]`

Represents the signal `CapabilitiesChanged` on the remote object.

Announce that there has been a change of capabilities on the given handle.

If the handle is zero, the capabilities refer to the connection itself, in some poorly defined way. This usage is deprecated and clients should ignore it.

Parameters:

  caps

  An array of structures containing:
  - an integer handle representing the contact
  - a string channel type
  - a bitwise OR of the contact's old generic capability flags
  - a bitwise OR of the contact's new generic capability flags
  - a bitwise OR of the contact's old type specific capability flags
  - a bitwise OR of the contact's new type specific capability flags

void Tp::Client::ConnectionInterfaceCapabilitiesInterface::invalidate | ( | Tp::DBusProxy * | proxy,
|  | const QString & | error,
|  | const QString & | message
| ) |  | `[protected, virtual]`

Reimplemented from Tp::AbstractInterface.